(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-lazy-ngfor', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-lazy-ngfor"] = {}, global.ng.core));
})(this, (function (exports, i0) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var NgxLazyNgforService = /** @class */ (function () {
        function NgxLazyNgforService() {
        }
        NgxLazyNgforService.prototype.loadMore = function (quantity, originalObject, lazyObject, counter) {
            if (originalObject.length - counter > quantity) {
                for (var i = counter; i < counter + quantity; i++) {
                    lazyObject.push(originalObject[i]);
                }
            }
            else {
                var rest = originalObject.length - counter;
                var limit = counter + rest;
                if (counter < originalObject.length) {
                    for (var i = counter; i < (limit); i++) {
                        lazyObject.push(originalObject[i]);
                    }
                }
            }
        };
        return NgxLazyNgforService;
    }());
    NgxLazyNgforService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgxLazyNgforService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }] });

    var NgxLazyNgforComponent = /** @class */ (function () {
        function NgxLazyNgforComponent() {
        }
        NgxLazyNgforComponent.prototype.ngOnInit = function () {
        };
        return NgxLazyNgforComponent;
    }());
    NgxLazyNgforComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgxLazyNgforComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: NgxLazyNgforComponent, selector: "lib-ngx-lazy-ngfor", ngImport: i0__namespace, template: "\n    <p>\n      ngx-lazy-ngfor works!\n    </p>\n  ", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-ngx-lazy-ngfor',
                        template: "\n    <p>\n      ngx-lazy-ngfor works!\n    </p>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return []; } });

    var QuantityDirective = /** @class */ (function () {
        function QuantityDirective(elementr) {
            this.elementr = elementr;
            this.element = elementr;
        }
        QuantityDirective.prototype.ngOnInit = function () {
            this.lazySize ? this.element.nativeElement.setAttribute("data-quantity", this.lazySize) : null;
        };
        return QuantityDirective;
    }());
    QuantityDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: QuantityDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    QuantityDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.16", type: QuantityDirective, selector: "[lazySize]", inputs: { lazySize: "lazySize" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: QuantityDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[lazySize]'
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { lazySize: [{
                    type: i0.Input,
                    args: ["lazySize"]
                }] } });

    var LazyForDirective = /** @class */ (function () {
        function LazyForDirective(elementr, ngxLazyNgforService, view, template, quantityDirective) {
            this.elementr = elementr;
            this.ngxLazyNgforService = ngxLazyNgforService;
            this.view = view;
            this.template = template;
            this.quantityDirective = quantityDirective;
            this.lazyObject = [];
            this.counter = 0;
            this.element = elementr;
        }
        Object.defineProperty(LazyForDirective.prototype, "lazyForOf", {
            set: function (collection) {
                var _this = this;
                this.quantity = this.element.nativeElement.parentElement.getAttribute("data-quantity") || "10";
                this.counter = 0;
                this.startOject = collection;
                this.view.clear();
                this.ngxLazyNgforService.loadMore(parseInt(this.quantity), this.startOject, this.lazyObject, this.counter);
                this.lazyObject.forEach(function (item, index) {
                    _this.view.createEmbeddedView(_this.template, { $implicit: item, index: index });
                });
                this.lazyObject = [];
                this.elementr.nativeElement.parentElement.addEventListener('scroll', function (event) {
                    ;
                    _this.emitScrollInBottom(event.target);
                });
            },
            enumerable: false,
            configurable: true
        });
        ;
        //detect if scroll position is in bottom of component
        LazyForDirective.prototype.isInBottom = function (element) {
            return element.scrollTop + element.offsetHeight >= element.scrollHeight;
        };
        //emit event when scroll position is in bottom of component
        LazyForDirective.prototype.emitScrollInBottom = function (element) {
            var _this = this;
            if (this.isInBottom(element)) {
                if (this.counter < this.startOject.length) {
                    this.counter += parseInt(this.quantity);
                    this.ngxLazyNgforService.loadMore(parseInt(this.quantity), this.startOject, this.lazyObject, this.counter);
                    this.lazyObject.forEach(function (item, index) {
                        _this.view.createEmbeddedView(_this.template, { $implicit: item, index: index });
                    });
                    this.lazyObject = [];
                }
            }
        };
        return LazyForDirective;
    }());
    LazyForDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LazyForDirective, deps: [{ token: i0__namespace.ElementRef }, { token: NgxLazyNgforService }, { token: i0__namespace.ViewContainerRef }, { token: i0__namespace.TemplateRef }, { token: QuantityDirective }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    LazyForDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.16", type: LazyForDirective, selector: "[lazyFor][lazyForOf]", inputs: { lazyForOf: "lazyForOf" }, providers: [QuantityDirective], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LazyForDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[lazyFor][lazyForOf]',
                        providers: [QuantityDirective]
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }, { type: NgxLazyNgforService }, { type: i0__namespace.ViewContainerRef }, { type: i0__namespace.TemplateRef }, { type: QuantityDirective }]; }, propDecorators: { lazyForOf: [{
                    type: i0.Input
                }] } });

    var NgxLazyNgforModule = /** @class */ (function () {
        function NgxLazyNgforModule() {
        }
        return NgxLazyNgforModule;
    }());
    NgxLazyNgforModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxLazyNgforModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforModule, declarations: [NgxLazyNgforComponent,
            LazyForDirective,
            QuantityDirective], exports: [NgxLazyNgforComponent,
            LazyForDirective,
            QuantityDirective] });
    NgxLazyNgforModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxLazyNgforModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            NgxLazyNgforComponent,
                            LazyForDirective,
                            QuantityDirective
                        ],
                        imports: [],
                        exports: [
                            NgxLazyNgforComponent,
                            LazyForDirective,
                            QuantityDirective
                        ]
                    }]
            }] });

    /*
     * Public API Surface of ngx-lazy-ngfor
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.LazyForDirective = LazyForDirective;
    exports.NgxLazyNgforComponent = NgxLazyNgforComponent;
    exports.NgxLazyNgforModule = NgxLazyNgforModule;
    exports.NgxLazyNgforService = NgxLazyNgforService;
    exports.QuantityDirective = QuantityDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-lazy-ngfor.umd.js.map
